#!/usr/local/bin/python
#
# WpreFile: A driver module for Wpre

from wpre import Wpre
class FileRules:
  def __init__(self):
    self.rules = {}
    

  def addRule(self, var, function):
    self.rules[var] = function

  def matchRule(self, var):
    if self.rules.has_key(var): return self.rules[var]
    else: return None


class WpreFile:
  def __init__(self, fileName, searchPath, env):
    self.fileName = fileName
    
    self.searchPath = searchPath
    self.env = env
    self.stack = []
    self.ruleTable = {}
    self.wpre = Wpre()
    self.fp = None
    

  def addFileRule(self, fileName, var, function):
    """Use this function to support more elaborate processing (i.e. multiple line)
       substitutions.
    """
    if not self.ruleTable.has_key(fileName):
      self.ruleTable[fileName] = FileRules()
    if callable(function):
      self.ruleTable[fileName].addRule(var, function)
    
  # Main method for CGI:used to print product to standard output    
  def process(self):
    for dir in self.searchPath:
      try:
        self.fp = open(dir + "/" + self.fileName, 'r')
      except:
        continue
      if self.fp != None: break

    if self.fp == None:
      print 'Unable to open file ', self.fileName
      return

    fileName = self.fileName
    
    while 1:
      line = self.fp.readline()
      
      if not line: break
      
      # process() an included file
      if line[0] == '>':
        includedFile = line[1:-1]
	self.fileName = includedFile
        currentFileState = (self.fileName, self.fp)
	self.stack.append(currentFileState)
	self.process()
	(self.fileName, self.fp) = self.stack.pop()
      else:
        self.wpre.compile(line)
	varList = self.wpre.getVars()
	ruleBasedEval = 0
	for var in varList:
	  if self.ruleTable.has_key(self.fileName):
	     fileRules = self.ruleTable[self.fileName]
	     function = fileRules.matchRule(var)
	     if function:
	       function(self.wpre, self.env)
	       ruleBasedEval = 1
        if not ruleBasedEval:
	  print self.wpre.evaluate(self.env),
    self.fp.close()

 


  # Main method for CGI: used to append product to list, a variable passed in as argument.
  def processList(self, list):
    for dir in self.searchPath:
      try:
        self.fp = open(dir + "/" + self.fileName, 'r')
      except:
        continue
      if self.fp != None: break

    if self.fp == None:
      print 'Unable to open file ', self.fileName
      return

    fileName = self.fileName
    

    while 1:
      line = self.fp.readline()
      if not line: break
      
      # process() an included file
      if line[0] == '>':
        includedFile = line[1:-1]
	self.fileName = includedFile
        currentFileState = (self.fileName, self.fp)
	self.stack.append(currentFileState)
	self.processList(list)
	(self.fileName, self.fp) = self.stack.pop()
      else:
        self.wpre.compile(line)
	varList = self.wpre.getVars()
	ruleBasedEval = 0
	for var in varList:
	  if self.ruleTable.has_key(self.fileName):
	     fileRules = self.ruleTable[self.fileName]
	     function = fileRules.matchRule(var)
	     if function:
	       function(self.wpre, self.env)
	       ruleBasedEval = 1
        if not ruleBasedEval:
	  list.append(self.wpre.evaluate(self.env))
    self.fp.close()

 















