#!/usr/local/python/bin/python


#
# wpreTest.py
#
# Script to test that the Wpre modules were copied to the correct 
# location and are available for use.
#
# NOTE: If this script crashes, check to make sure that the 
#       correct Python interpreter is being used. The above path
#       is set to the default installation location of Python.
#
# Author: John Shafaee
# Date:   02/13/2000
#


from wpre import Wpre
from WpreFile import WpreFile


def testWpre():
	print "\nTesting the Wpre module...."
	
	raw = '`title `first_name `last_name\n'
	raw = raw + '\t`address_1\n'
	raw = raw + '\t`address_2\n'
	raw = raw + '\t`city, `state `zip_code'

	title = 'Mr.'
	first_name = 'John'
	last_name = 'Shafaee'
	address_1 = '6304 N. Kenmore'
	address_2 = 'Apt. 2'
	city = 'Chicago'
	state = 'IL'
	zip_code = '60660'

	print "Raw text: "
	print "\t", raw
	print "\ntitle      defined as: ", title
	print "first_name defined as: ", first_name
	print "last_name  defined as: ", last_name
	print "address_1  defined as: ", address_1
	print "address_2  defined as: ", address_2
	print "city       defined as: ", city
	print "state      defined as: ", state
	print "zip_code   defined as: ", zip_code

	print "\nCreating a wpre object..."
	wpobj = Wpre()
	
	print "\nCompiling raw text..."
	wpobj.compile( raw )

	print "\nEvaluating and processing..."
	outputText = wpobj.evaluate( vars() )

	print "\nResulting text:"
	print "\t", outputText

	print "\n\n*** End of Wpre Test ***\n\n"


def testWpreFile():
	print "Testing the WpreFile module...."
	
	print "\nReading tempalte from: wpreFileTest.html"
	
	title = 'Mrs.'
	first_name = 'Joan'
	last_name = 'Shafaer'
	address_1 = '4 S. Kenmore'
	address_2 = 'Apt. 12'
	city = 'Chicago'
	state = 'IL'
	zip_code = '60661'


	print "\ntitle      defined as: ", title
	print "first_name defined as: ", first_name
	print "last_name  defined as: ", last_name
	print "address_1  defined as: ", address_1
	print "address_2  defined as: ", address_2
	print "city       defined as: ", city
	print "state      defined as: ", state
	print "zip_code   defined as: ", zip_code

	print "\nCreating a WpreFile object..."
	wpobj = WpreFile( 'wpreFileTest.html', ['.'], vars() )

	print "\nEvaluating and processing..."
	wpobj.process()


	print "\n\n*** End of WpreFile Test ***\n\n"




def Main():
	testWpre()	

	testWpreFile()

	print "**** INSTALLATION IS SUCCESSFUL ****\n\n"


Main()

